#本程式碼之使用請參考《傻瓜也會跑統計Ⅱ》單元43

#每次執行本程式前，都請先按Ctrl+L，清空R console視窗，再執行程式

#***** 需注意處 *****
#讀檔案
dta <- read.csv('hlm1_data.csv',header=T, fileEncoding = 'UTF-8-BOM')

#載入HLM所需套件
library(lme4)
library(lmerTest)
library(MuMIn)

#***** 需修改處1 *****
#計算 ICC
result0 <- lmer(y ~ 1+(1|group),data = dta)
r.squaredGLMM(result0)[2]

#***** 需修改處2 *****
#進行HLM分析
result <- lmer(y ~ p1+p2+g

#***** 需修改處3 *****
+(1+p1+p2|group),data = dta)
summary(result)

#取小數點三位，作表格用
write.csv(round(coef(summary(result)),3),'hlm1_table.csv')